Bug 877497 - Screensaver exits on segfault, unlocking the screen
Summary: Screensaver exits on segfault, unlocking the screen
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: xfce-utils
Version: 16
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kevin Fenzi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-11-16 17:06 UTC by Denys Vlasenko
Modified: 2013-02-14 01:48 UTC (History)
2 users (show)

Fixed In Version:
Clone Of:
Environment:
Last Closed: 2013-02-14 01:48:48 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)
Proposed patch (1.19 KB, patch)
2012-11-16 17:06 UTC, Denys Vlasenko
no flags Details | Diff

Description Denys Vlasenko 2012-11-16 17:06:07 UTC
Description of problem:
I use xlock from xlockmore package as my screensaver.
xlock from xlockmore is buggy and regularly segfaults. This unlocks locked X session.

Version-Release number of selected component (if applicable):
xfce-utils-4.8.3-2.fc16.i686

How reproducible:
Random

Steps to Reproduce:
Run xlock, then watch xlock run randon screensavers. When one of them SEGVs or FPEs, witness that therefore lock was broken w/o password.


xlockmore maintainer in Fedora is unwilling to fix it: see bug 874484
Upstream project is not very active: see http://calypso.tux.org/pipermail/xlock-develop/
The source is a mess. I am not familiar with Xlib.
I'm afraid I can't implement the fix in xlockmore myself; and I have doubts it will be accepted.

Can we for now wrap xlock invocation in xflock4 script so that it is autorestarted if it died on a signal?

Comment 1 Denys Vlasenko 2012-11-16 17:06:56 UTC
Created attachment 646454 [details]
Proposed patch

Comment 2 Kevin Fenzi 2012-11-16 17:19:22 UTC
Can you not just switch to xscreensaver? Possibly with a static lockscreen?

Comment 3 Denys Vlasenko 2012-11-20 16:44:49 UTC
(In reply to comment #2)
> Can you not just switch to xscreensaver? Possibly with a static lockscreen?

Do I want to have an idle process with 23 shared libraries be loaded at all times, _doing nothing at all_? No, not really...

ldd xscreensaver 
	linux-gate.so.1 =>  (0xb7757000)
	libXmu.so.6 => /usr/lib/libXmu.so.6 (0x4afba000)
	libXi.so.6 => /usr/lib/libXi.so.6 (0xb7730000)
	libXxf86vm.so.1 => /usr/lib/libXxf86vm.so.1 (0x4be63000)
	libXrandr.so.2 => /usr/lib/libXrandr.so.2 (0x4b812000)
	libXrender.so.1 => /usr/lib/libXrender.so.1 (0x4b779000)
	libXxf86misc.so.1 => /usr/lib/libXxf86misc.so.1 (0xb772c000)
	libXinerama.so.1 => /usr/lib/libXinerama.so.1 (0x4ba0e000)
	libSM.so.6 => /usr/lib/libSM.so.6 (0x4c320000)
	libICE.so.6 => /usr/lib/libICE.so.6 (0x4c32a000)
	libXt.so.6 => /usr/lib/libXt.so.6 (0x4bb75000)
	libX11.so.6 => /usr/lib/libX11.so.6 (0x4b3ac000)
	libXext.so.6 => /usr/lib/libXext.so.6 (0xb7718000)
	libpam.so.0 => /lib/libpam.so.0 (0xb7709000)
	libdl.so.2 => /lib/libdl.so.2 (0xb7704000)
	libcrypt.so.1 => /lib/libcrypt.so.1 (0xb76d3000)
	libc.so.6 => /lib/libc.so.6 (0xb7525000)
	libuuid.so.1 => /lib/libuuid.so.1 (0xb751e000)
	libxcb.so.1 => /usr/lib/libxcb.so.1 (0x4b4ec000)
	libgcc_s.so.1 => /lib/libgcc_s.so.1 (0xb7501000)
	libaudit.so.1 => /lib/libaudit.so.1 (0xb74e4000)
	/lib/ld-linux.so.2 (0xb7758000)
	libfreebl3.so => /lib/libfreebl3.so (0xb7494000)
	libXau.so.6 => /usr/lib/libXau.so.6 (0x4b4e7000)

Comment 4 Kevin Fenzi 2012-11-20 17:39:40 UTC
Well, up to you... 

If not that, how about you setup a custom launcher that wraps it as you like? 

I really don't want to carry this hack for everyone... in fact I would be more inclined to asking upstream to remove support for it so others don't run into this problem. They should also remove gnome-screensaver from there too... ;(

Comment 5 Denys Vlasenko 2012-12-12 12:49:03 UTC
(In reply to comment #4)
> Well, up to you... 
> 
> If not that, how about you setup a custom launcher that wraps it as you
> like? 

Well, technically I surely can do that, but isn't xflock4 a wrapper already?

BTW, xlock'ed screen got much more stable after my patch, but after about a week I caught it "auto-unlocking" again. Debug logging detected it exiting with 1. Thus, I modified the loop to allow only exit codes 0, TERM and KILL:

    # xlock from xlockmore package has many plugins.
    # No chance all of them will ever be thoroughly debugged.
    # Segfaults were observed to make it exit and unlock the screen.
    # Pathetic...
    # Moreover, I observed rare random exits with exit code 1,
    # with no messages explaining what happened.
    # Let's allow exiting only with 0, TERM and KILL:
    while ! xlock "$@"; do
        r=$?
        test $r -gt 128 && {
            sig=$((r-128))
            test $sig -eq 15 && exit $r # TERM is ok
            test $sig -eq 9 && exit $r  # KILL is ok
        }
        #logger "xlock exited with exit code $r, restarting"
    done


> I really don't want to carry this hack for everyone... in fact I would be more inclined to asking upstream to remove support for it so others don't run into this problem.

I think the problem is generic to all screensavers.

Comment 6 Fedora End Of Life 2013-01-16 23:25:21 UTC
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 7 Fedora End Of Life 2013-02-14 01:48:52 UTC
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.